=== debian/changelog ===
gzdoom (4.2.1-1) unstable; urgency=medium

  * Initial release (Closes: #nnnn)  <nnnn is the bug number of your ITP>

 -- pavroo <pavroo@onet.eu>  Mon, 23 Sep 2019 00:18:52 +0200
