=== debian/control ===
Source: gzdoom
Section: games
Priority: optional
Maintainer: pavroo <pavroo@onet.eu>
Build-Depends: debhelper (>= 11)
Standards-Version: 4.1.3
Homepage: <insert the upstream URL, if relevant>
#Vcs-Browser: https://salsa.debian.org/debian/gzdoom
#Vcs-Git: https://salsa.debian.org/debian/gzdoom.git

Package: gzdoom
Architecture: all
Depends: ${misc:Depends}
Description: <insert up to 60 chars description>
 <insert long description, indented with spaces>
